<div class="full-width full-height flex-column neutral-background-color">
  <div [attr.data-test-toolbar-id]="'campaign-toolbar'">
    <div class="m-5 font-20-px flex-fixed-size flex-row">
      <span>
        <i
          nz-icon
          nz-dropdown
          [nzDropdownMenu]="creationMenu"
          nzType="sqtm-core-generic:add"
          nzTheme="outline"
          [ngClass]="creationButtonClasses$ | async"
          [attr.data-test-toolbar-button-id]="'create-button'"
        ></i>
      </span>
      <sqtm-core-toggle-icon
        class="m-l-30"
        [attr.data-test-toolbar-button-id]="'copy-button'"
        [active]="tree.canCopy$ | async"
        (clickedInActiveMode)="copy()"
      >
        <i
          nz-icon
          nzType="sqtm-core-generic:copy"
          nzTheme="outline"
          nz-tooltip
          [nzTooltipTitle]="'sqtm-core.generic.label.copy' | translate"
          nzTooltipPlacement="bottom"
          class="action-icon-size"
        ></i>
      </sqtm-core-toggle-icon>
      <sqtm-core-toggle-icon
        class="m-l-10"
        [attr.data-test-toolbar-button-id]="'paste-button'"
        [active]="tree.canPaste$ | async"
        (clickedInActiveMode)="paste()"
      >
        <i
          nz-icon
          nzType="sqtm-core-generic:paste"
          nzTheme="outline"
          nz-tooltip
          class="action-icon-size"
          [nzTooltipTitle]="
            'sqtm-core.generic.label.paste-with-shortcut' | translate
          "
          nzTooltipPlacement="bottom"
        ></i>
      </sqtm-core-toggle-icon>

      @if (referentialDataService.canDeleteFromFront$ | async) {
        <sqtm-core-toggle-icon
          class="m-l-10"
          [attr.data-test-toolbar-button-id]="'delete-button'"
          [active]="tree.canDelete$ | async"
          (clickedInActiveMode)="delete()"
        >
          <i
            nz-icon
            nzType="sqtm-core-generic:delete"
            nzTheme="outline"
            nz-tooltip
            class="action-icon-size"
            [nzTooltipTitle]="
              'sqtm-core.generic.label.delete-with-shortcut' | translate
            "
            nzTooltipPlacement="bottom"
          ></i>
        </sqtm-core-toggle-icon>
      }

      <span class="m-l-auto">
        <i
          nz-icon
          nz-dropdown
          [nzDropdownMenu]="exportMenu"
          nzType="sqtm-core-generic:export"
          nzTheme="outline"
          [ngClass]="exportButtonClasses$ | async"
          [attr.data-test-toolbar-button-id]="'export-button'"
        ></i>
      </span>
      <span class="m-l-10">
        <i
          nz-icon
          nz-dropdown
          [nzDropdownMenu]="pluginMenu"
          nzType="star"
          nzTheme="outline"
          [ngClass]="wizardButtonClasses$ | async"
          [attr.data-test-toolbar-button-id]="'wizard-button'"
        ></i>
      </span>
      <span class="m-l-10">
        <i
          nz-icon
          nzType="sqtm-core-generic:settings"
          nzTheme="outline"
          nz-popover
          [nzPopoverContent]="settingsMenu"
          class="current-workspace-button action-icon-size"
          [style.transform-y]="'rotate(90)'"
          [attr.data-test-toolbar-button-id]="'settings-button'"
        ></i>
      </span>
      <span class="m-l-10 m-r-20" (click)="navigateToResearch()">
        <i
          nz-icon
          nzType="sqtm-core-tree:search"
          nzTheme="outline"
          class="current-workspace-button action-icon-size"
          nz-tooltip
          [nzTooltipTitle]="'sqtm-core.generic.label.research' | translate"
          [attr.data-test-toolbar-button-id]="'research-button'"
        ></i>
      </span>
    </div>
    <div class="parent-milestone-container-state">
      @if (
        this.referentialDataService.milestoneModeData$ | async;
        as milestoneState
      ) {
        @if (
          milestoneState.milestoneModeEnabled &&
          milestoneState.milestoneFeatureEnabled
        ) {
          <ng-container class="m-l-30">
            <div
              class="milestone-container-state"
              nz-dropdown
              [nzDropdownMenu]="milestoneMenu"
              [nzPlacement]="'bottomCenter'"
            >
              <i
                nz-icon
                nzType="sqtm-core-nav:milestone"
                class="m-l-2 current-workspace-button action-icon-size"
                [attr.data-test-toolbar-button-id]="'milestone-button'"
              ></i>
              <span>
                {{ milestoneState.selectedMilestone.label }}
              </span>
            </div>
          </ng-container>
        }
      }
    </div>
  </div>

  <div class="full-width full-height" sqtmCoreTreeKeyboardShortcut>
    <sqtm-core-grid
      class="sqtm-core-prevent-selection-in-grid"
    ></sqtm-core-grid>
  </div>
</div>

<nz-dropdown-menu #creationMenu="nzDropdownMenu">
  <ul nz-menu [attr.data-test-menu-id]="'create-menu'">
    <li
      nz-menu-item
      [attr.data-test-menu-item-id]="'new-folder'"
      [nzDisabled]="!(canCreateCampaignFolder$ | async)"
      (click)="openCreateFolder()"
    >
      {{ 'sqtm-core.test-case-workspace.tree.button.new-folder' | translate }}
    </li>
    <li
      nz-menu-item
      [attr.data-test-menu-item-id]="'new-campaign'"
      [nzDisabled]="!(canCreateCampaign$ | async)"
      (click)="openCreateCampaign()"
    >
      {{ 'sqtm-core.campaign-workspace.tree.button.new-campaign' | translate }}
    </li>
    <li
      nz-menu-item
      [attr.data-test-menu-item-id]="'new-iteration'"
      [nzDisabled]="!(canCreateIteration$ | async)"
      (click)="openCreateIteration()"
    >
      {{ 'sqtm-core.campaign-workspace.tree.button.new-iteration' | translate }}
    </li>
    <li
      nz-menu-item
      [attr.data-test-menu-item-id]="'new-suite'"
      [nzDisabled]="!(canCreateSuite$ | async)"
      (click)="openCreateSuite()"
    >
      {{ 'sqtm-core.campaign-workspace.dialog.title.new-suite' | translate }}
    </li>
    <li
      nz-menu-item
      [attr.data-test-menu-item-id]="'new-sprint-group'"
      [nzDisabled]="!(canCreateSprintGroup$ | async)"
      (click)="openCreateSprintGroup()"
    >
      {{
        'sqtm-core.campaign-workspace.tree.button.new-sprint-group' | translate
      }}
    </li>
    <li
      nz-menu-item
      [attr.data-test-menu-item-id]="'new-sprint'"
      [nzDisabled]="!(canCreateSprint$ | async)"
      (click)="openCreateSprint()"
    >
      {{ 'sqtm-core.campaign-workspace.tree.button.new-sprint' | translate }}
    </li>
  </ul>
</nz-dropdown-menu>

<nz-dropdown-menu #exportMenu>
  <ul nz-menu [attr.data-test-menu-id]="'export-menu'">
    <li
      nz-menu-item
      [attr.data-test-menu-item-id]="'light-export'"
      [nzDisabled]="!(canExportCampaign$ | async)"
    >
      <a
        [href]="exportCampaign('L') | async"
        [ngStyle]="getExportMenuItemStyle(canExportCampaign$ | async)"
      >
        {{
          'sqtm-core.campaign-workspace.tree.button.export.light' | translate
        }}
      </a>
    </li>
    <li
      nz-menu-item
      [attr.data-test-menu-item-id]="'standard-export'"
      [nzDisabled]="!(canExportCampaign$ | async)"
    >
      <a
        [href]="exportCampaign('S') | async"
        [ngStyle]="getExportMenuItemStyle(canExportCampaign$ | async)"
      >
        {{
          'sqtm-core.campaign-workspace.tree.button.export.standard' | translate
        }}
      </a>
    </li>
    <li
      nz-menu-item
      [attr.data-test-menu-item-id]="'full-export'"
      [nzDisabled]="!(canExportCampaign$ | async)"
    >
      <a
        [href]="exportCampaign('F') | async"
        [ngStyle]="getExportMenuItemStyle(canExportCampaign$ | async)"
      >
        {{ 'sqtm-core.campaign-workspace.tree.button.export.full' | translate }}
      </a>
    </li>
  </ul>
</nz-dropdown-menu>

<nz-dropdown-menu #pluginMenu>
  <ul nz-menu [attr.data-test-menu-id]="'wizard-menu'">
    @for (menuItem of wizardMenuItems$ | async; track menuItem) {
      <li
        nz-menu-item
        [nzDisabled]="!menuItem.enabled"
        (click)="navigateToPlugin(menuItem)"
      >
        {{ menuItem.wizardMenu.label }}
      </li>
    }
  </ul>
</nz-dropdown-menu>

<ng-template #settingsMenu>
  <span class="current-workspace-main-color sqtm-tree-configuration-title">
    <div
      style="display: flex; justify-content: center"
      [attr.data-test-menu-id]="'collapse'"
    >
      <button
        nz-button
        nzType="primary"
        [attr.data-test-menu-item-id]="'collapse-tree'"
        [disabled]="!(canBeCollapsed$ | async)"
        (click)="collapseTree()"
      >
        {{ 'sqtm-core.tree-picker.generic.collapse-tree.label' | translate }}
      </button>
    </div>
  </span>
  <div class="spacer m-b-10"></div>
  <span class="current-workspace-main-color sqtm-tree-configuration-title">{{
    'sqtm-core.tree-picker.generic.sort.label' | translate
  }}</span>
  <div [attr.data-test-menu-id]="'sort-menu'">
    <nz-radio-group [(ngModel)]="sortValue" (ngModelChange)="changeSort()">
      <label
        nz-radio
        nzValue="ALPHABETICAL"
        [attr.data-test-menu-item-id]="'sort-alphabetical'"
        >{{
          'sqtm-core.tree-picker.generic.sort.alphabetic' | translate
        }}</label
      >
      <label
        nz-radio
        nzValue="POSITIONAL"
        [attr.data-test-menu-item-id]="'sort-positional'"
        >{{
          'sqtm-core.tree-picker.generic.sort.positional' | translate
        }}</label
      >
    </nz-radio-group>
  </div>
  <div class="spacer m-b-10"></div>
  <span class="current-workspace-main-color sqtm-tree-configuration-title">{{
    'sqtm-core.tree-picker.generic.configuration.truncate-too-long-names.title'
      | translate
  }}</span>
  <div [attr.data-test-menu-id]="'truncate-menu'">
    <nz-radio-group
      [(ngModel)]="truncateNameValue"
      (ngModelChange)="changeEllipsisDirection()"
    >
      <label
        nz-radio
        nzValue="TO-THE-RIGHT"
        [attr.data-test-menu-item-id]="'truncate-to-the-right'"
        >{{
          'sqtm-core.tree-picker.generic.configuration.truncate-too-long-names.to-the-right'
            | translate
        }}</label
      >
      <label
        nz-radio
        nzValue="TO-THE-LEFT"
        [attr.data-test-menu-item-id]="'truncate-to-the-left'"
        >{{
          'sqtm-core.tree-picker.generic.configuration.truncate-too-long-names.to-the-left'
            | translate
        }}</label
      >
    </nz-radio-group>
  </div>
</ng-template>

<nz-dropdown-menu #milestoneMenu="nzDropdownMenu">
  <ul nz-menu [attr.data-test-menu-id]="'milestone-menu'">
    <li
      nz-menu-item
      [attr.data-test-menu-item-id]="'change-active-milestone'"
      (click)="openMilestoneSelect()"
    >
      {{ 'sqtm-core.dialog.milestone.picker.other-single' | translate }}
    </li>
    <li
      nz-menu-item
      [attr.data-test-menu-item-id]="'show-active-milestone-dashboard'"
      [nzDisabled]="milestoneDashboardIsVisible()"
      (click)="navigateToMilestoneDashboard()"
    >
      {{ 'sqtm-core.tree-picker.generic.milestone.dashboard' | translate }}
    </li>
  </ul>
</nz-dropdown-menu>
